com.holonplatform.auth.jwt

## Interface JwtConfigProperties

- All Superinterfaces:
    ConfigPropertySet
  All Known Implementing Classes:
    JwtConfigProperties.JwtConfigPropertiesImpl

      public interface JwtConfigProperties
      extends ConfigPropertySet

  A `ConfigPropertySet` for JWT configuration.
  Since:
    5.0.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `JwtConfigProperties.JwtConfigPropertiesImpl` Default implementation

    - ### Nested classes/interfaces inherited from interface com.holonplatform.core.config.ConfigPropertySet

      `ConfigPropertySet.Builder<C extends ConfigPropertySet>, ConfigPropertySet.ConfigurationException`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static long` | `DEFAULT_EXPIRE_TIME` Default JWT expire time
    `static String` | `DEFAULT_SIGNATURE_ALGORITHM` Default JWT signature algorithm
    `static ConfigProperty<Long>` | `EXPIRE_TIME_DAYS` JWT token expire time in days (numeric)
    `static ConfigProperty<Long>` | `EXPIRE_TIME_HOURS` JWT token expire time in hours (numeric)
    `static ConfigProperty<Long>` | `EXPIRE_TIME_MINUTES` JWT token expire time in minutes (numeric)
    `static ConfigProperty<Long>` | `EXPIRE_TIME_MS` JWT token expire time in milliseconds (numeric)
    `static ConfigProperty<Long>` | `EXPIRE_TIME_SECONDS` JWT token expire time in seconds (numeric)
    `static ConfigProperty<Boolean>` | `INCLUDE_DETAILS` Include `Authentication` details in JWT token as claims (boolean)
    `static ConfigProperty<Boolean>` | `INCLUDE_PERMISSIONS` Include `Authentication` permissions in JWT token as claims (boolean)
    `static ConfigProperty<String>` | `ISSUER` Required JWT issuer
    `static String` | `NAME` Configuration property set name
    `static ConfigProperty<String>` | `PRIVATE_KEY` JWT sign private key (base64 encoded)
    `static ConfigProperty<String>` | `PRIVATE_KEY_FILE` JWT sign private key (file name)
    `static ConfigProperty<String>` | `PUBLIC_KEY` JWT sign public key (base64 encoded)
    `static ConfigProperty<String>` | `PUBLIC_KEY_FILE` JWT sign public key (file name)
    `static ConfigProperty<String>` | `SHARED_KEY` JWT sign shared key (base64 encoded)
    `static ConfigProperty<String>` | `SIGNATURE_ALGORITHM` JWT signature algorithm name

  - ### Method Summary

    All Methods Static Methods Instance Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `static ConfigPropertySet.Builder<JwtConfigProperties>` | `builder()` Builder to create property set instances bound to a property data source
    `default String` | `getName()` Configuration property set name, used as property definition prefix.

    - ### Methods inherited from interface com.holonplatform.core.config.ConfigPropertySet

      `getConfigPropertyValue, getSubPropertiesUsingPrefix, hasConfigProperty`

- - ### Field Detail

    - #### NAME

          static final String NAME

      Configuration property set name
      See Also:
        Constant Field Values

    - #### DEFAULT_EXPIRE_TIME

          static final long DEFAULT_EXPIRE_TIME

      Default JWT expire time
      See Also:
        Constant Field Values

    - #### DEFAULT_SIGNATURE_ALGORITHM

          static final String DEFAULT_SIGNATURE_ALGORITHM

      Default JWT signature algorithm
      See Also:
        Constant Field Values

    - #### ISSUER

          static final ConfigProperty<String> ISSUER

      Required JWT issuer

    - #### SHARED_KEY

          static final ConfigProperty<String> SHARED_KEY

      JWT sign shared key (base64 encoded)

    - #### PUBLIC_KEY

          static final ConfigProperty<String> PUBLIC_KEY

      JWT sign public key (base64 encoded)

    - #### PUBLIC_KEY_FILE

          static final ConfigProperty<String> PUBLIC_KEY_FILE

      JWT sign public key (file name)

    - #### PRIVATE_KEY

          static final ConfigProperty<String> PRIVATE_KEY

      JWT sign private key (base64 encoded)

    - #### PRIVATE_KEY_FILE

          static final ConfigProperty<String> PRIVATE_KEY_FILE

      JWT sign private key (file name)

    - #### SIGNATURE_ALGORITHM

          static final ConfigProperty<String> SIGNATURE_ALGORITHM

      JWT signature algorithm name
      See Also:
        `SignatureAlgorithm`

    - #### EXPIRE_TIME_MS

          static final ConfigProperty<Long> EXPIRE_TIME_MS

      JWT token expire time in milliseconds (numeric)

    - #### EXPIRE_TIME_SECONDS

          static final ConfigProperty<Long> EXPIRE_TIME_SECONDS

      JWT token expire time in seconds (numeric)

    - #### EXPIRE_TIME_MINUTES

          static final ConfigProperty<Long> EXPIRE_TIME_MINUTES

      JWT token expire time in minutes (numeric)

    - #### EXPIRE_TIME_HOURS

          static final ConfigProperty<Long> EXPIRE_TIME_HOURS

      JWT token expire time in hours (numeric)

    - #### EXPIRE_TIME_DAYS

          static final ConfigProperty<Long> EXPIRE_TIME_DAYS

      JWT token expire time in days (numeric)

    - #### INCLUDE_DETAILS

          static final ConfigProperty<Boolean> INCLUDE_DETAILS

      Include `Authentication` details in JWT token as claims (boolean)

    - #### INCLUDE_PERMISSIONS

          static final ConfigProperty<Boolean> INCLUDE_PERMISSIONS

      Include `Authentication` permissions in JWT token as claims (boolean)

  - ### Method Detail

    - #### getName

          default String getName()

      Description copied from interface: `ConfigPropertySet`
      Configuration property set name, used as property definition prefix.
      Specified by:
        `getName` in interface `ConfigPropertySet`
      Returns:
        Configuration properties set name (not null)

    - #### builder

          static ConfigPropertySet.Builder<JwtConfigProperties> builder()

      Builder to create property set instances bound to a property data source
      Returns:
        ConfigPropertySet builder

Copyright © 2017 The Holon Platform. All rights reserved.